/*
 * Created on 05.07.2004
 */
package streamfile;

import javax.swing.*;
import java.awt.event.*;
import javax.sound.sampled.*;
import java.io.*;
import java.awt.*;

/**
 * @author jl
 */
public class StreamFile extends JFrame {

	public static void main(String[] args) {
		StreamFile myFrame = new StreamFile();
		myFrame.getContentPane().setLayout(new FlowLayout());
		AudioAdapter aa = new AudioAdapter();
		JButton playButton = new JButton("Play");
		playButton.addActionListener(aa);
		myFrame.getContentPane().add(playButton);
		JButton stopButton = new JButton("Stop");
		stopButton.addActionListener(aa);
		myFrame.getContentPane().add(stopButton);
		myFrame.setSize(100, 100);
		myFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		myFrame.show();		
	}
}
class AudioAdapter implements ActionListener
{
	public void actionPerformed(ActionEvent e)
	{
		if(e.getActionCommand().equals("Play"))
		{
			AudioThread.stopRequested = false;
			new AudioThread().start();
		}
		else if(e.getActionCommand().equals("Stop"))
			AudioThread.stopRequested = true;
	}
}

class AudioThread extends Thread
{
	static volatile boolean stopRequested;
	
	public void run()
	{		
		byte[] bufferIn = new byte[2000];
		byte[] bufferOut = new byte[2000];

		try
		{
			File inFile = new File("C:\\WINDOWS\\Media\\Windows XP-Startvorgang.wav");
			AudioFileFormat aff = AudioSystem.getAudioFileFormat(inFile);
			AudioFormat af = aff.getFormat();
			if(af.isBigEndian())
				throw new Exception("no litte endian");
			if(af.getChannels() != 2)
				throw new Exception("no stereo file");
			if(af.getSampleSizeInBits() != 16)
				throw new Exception("no 16 bit file");
				
			AudioInputStream inStream = AudioSystem.getAudioInputStream(inFile);				
	
			DataLine.Info lineInfo = new DataLine.Info(SourceDataLine.class, af);
			SourceDataLine myLine = (SourceDataLine)AudioSystem.getLine(lineInfo);
			myLine.open(af, 12000);		
			myLine.start();
			
			while(!stopRequested)
			{
				int numBytesRead = inStream.read(bufferIn);
				if(numBytesRead <= 0)
					break;
								
				int pos = 0;
		
				for(int i = 0; i < numBytesRead/4; i++)
				{
					for(int ch = 0; ch < 2; ch++)
					{
						int oldPos = pos;
						int lo = bufferIn[pos++];
						int hi = bufferIn[pos++];
						short v = (short)((hi << 8) | (lo & 0xFF));
						double in = v/(double)(Short.MAX_VALUE+1);
							
						double out = 0.5*in; // a simple example
												
						short w = (short)(out*Short.MAX_VALUE);
						bufferOut[oldPos++] = (byte)(w & 0xFF);
						bufferOut[oldPos] = (byte)(w >> 8);
					}
				}
				myLine.write(bufferOut, 0, numBytesRead);
			}
			myLine.drain();
			myLine.stop();
			inStream.close();
		}
		catch(Exception e)
		{
			throw new RuntimeException(e);
		}		
	}
}
